/*
 * qdvbts_priv.h
 *
 *  Created on: May 17, 2013
 *      Author: root
 */

#ifndef _QDVBTS_PRIV_H_
#define _QDVBTS_PRIV_H_

/* Parser helpers */
#define QDVB_CheckFinish() if (dsIndex>=dsSize) goto dsBounds;
#define QDVB_GotError() goto dsBounds;
#define QDVB_GotSuccess() goto dsOk;
#define QDVB_NextPos() if (dsMask == 0x01) { dsMask = 0x80; dsIndex++; } else dsMask >>= 1;
#define QDVB_NextPosW() if (dsMask == 0x80) { dsMask = 0x01; dsIndex++; } else dsMask <<= 1;
#define QDVB_NextBit(D) D <<= 1; if (dsData[dsIndex] & dsMask) D |= 1; QDVB_NextPos();
#define QDVB_ReadBits(D, X) D = 0; dsBits = X; while(dsBits--) { QDVB_CheckFinish(); QDVB_NextBit(D); }
#define QDVB_ReadBitsNZ(D, X) dsBits = X; while(dsBits--) { QDVB_CheckFinish(); QDVB_NextBit(D); }
#define QDVB_ReadBitsCheck(X, C) nDummy2 = 0; QDVB_ReadBits(nDummy2, X); if (nDummy2 != C) goto dsBounds;
#define QDVB_SkipBits(X) dsBits = X; while(dsBits--) { QDVB_CheckFinish(); QDVB_NextBit(nDummy); }
#define QDVB_Start(P, N) uint8_t* dsData = (uint8_t*)P; long dsSize; \
	uint8_t dsMask = 0x80; long dsIndex = 0; long dsBits = 0; bool dsBCError = false; long nDummy; uint64_t nDummy2; nDummy = 0; nDummy2 = 0; dsSize = (long)N; nDummy2 = nDummy2; dsBCError = dsBCError;

#define QDVB_StartWrite(P, N) uint8_t* dsData = (uint8_t*)P; long& dsSize = N; \
	uint8_t dsMask = 0x80; long dsIndex = 0; long dsBits = 0; bool dsBCError = false; long nDummy; uint64_t nDummy2; uint64_t nData; nData = 0; nDummy = 0; nDummy2 = 0; dsSize = dsSize; nDummy = nDummy; nDummy2 = nDummy2; dsBCError = dsBCError;
#define QDVB_WriteNextBit() if (nData & nDummy2) dsData[dsIndex] |= dsMask; else dsData[dsIndex] &= ~dsMask; QDVB_NextPos();
#define QDVB_WriteBits(D, X) dsBits = X; nData = (uint64_t)D; nDummy2 = (uint64_t)(((uint64_t)1) << (uint64_t)(dsBits - 1)); while(dsBits--) { QDVB_WriteNextBit(); nDummy2 >>= 1; }

#define QDVB_BoundsError dsOk: goto dsExit; goto dsOk; dsBounds: dsBCError = true; dsExit:;
#define QDVB_BCError() !dsBCError
#define QDVB_RoundNextByte() if (dsMask != 0x80) { dsMask = 0x80; dsIndex++; }
#define QDVB_CurrentBuffer() (uint8_t*)&dsData[dsIndex]
#define QDVB_CurrentSize() (dsSize - dsIndex)

#endif /* QDVBTS_PRIV_H_ */
